"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var styled_components_1 = __importDefault(require("styled-components"));
var react_color_1 = require("react-color");
var ContentText_1 = __importDefault(require("./components/ContentText"));
var AOIModal_1 = __importDefault(require("./components/AOIModal"));
var components_1 = require("@jeongyk92/react-customform/dist/components");
var AOIViewer_1 = __importDefault(require("./components/AOIViewer"));
var useInfoList_1 = __importDefault(require("./hooks/useInfoList"));
var useInput_1 = __importDefault(require("./hooks/useInput"));
var ContentQuestion_1 = __importDefault(require("./components/ContentQuestion"));
var Buttons_1 = require("./styles/Buttons");
var FontSVG_1 = __importDefault(require("./assets/svg/FontSVG"));
var ContentEditor = function (_a) {
    var alert = _a.alert, Swal = _a.Swal, setLoading = _a.setLoading, data = _a.data, onClose = _a.onClose, onSave = _a.onSave, onDelete = _a.onDelete;
    var _b = (0, useInfoList_1.default)(), fontList = _b.fontList, languageList = _b.languageList, textTypeList = _b.textTypeList, textLevelList = _b.textLevelList, textActiveList = _b.textActiveList, textContentLevelList = _b.textContentLevelList;
    var _c = (0, useInput_1.default)(data ? data.text.name : ""), textTitle = _c[0], setTextTitle = _c[1];
    var _d = (0, react_1.useState)(function () { return (data ? data.text.language : languageList[0]); }), textLanguage = _d[0], setTextLanguage = _d[1];
    var _e = (0, react_1.useState)(function () { return (data ? data.text.domain : textTypeList[0]); }), textType = _e[0], setTextType = _e[1];
    var _f = (0, react_1.useState)(function () { return (data ? data.text.level : textLevelList[0]); }), textLevel = _f[0], setTextLevel = _f[1];
    var _g = (0, react_1.useState)(function () { return (data ? data.textset.textActive : textActiveList[0]); }), textActive = _g[0], setTextActive = _g[1];
    var _h = (0, react_1.useState)(function () {
        return data ? data.textset.textContentLevel : textContentLevelList[0];
    }), textContentLevel = _h[0], setTextContentLevel = _h[1];
    // const [selectAlign] = useState<"justify" | "left" | "center" | "right">("justify");
    var selectAlign = (0, react_1.useMemo)(function () { return "justify"; }, []);
    var _j = (0, react_1.useState)(function () { return (data ? data.text.css["font-family"] : fontList[0]); }), selectFont = _j[0], setSelectFont = _j[1];
    var _k = (0, react_1.useState)(function () { return (data ? data.text.css["font-size"] : "36px"); }), selectFontSize = _k[0], setSelectFontSize = _k[1];
    var _l = (0, react_1.useState)(function () {
        if (data && data.text.css) {
            var lineHeight = +data.text.css["line-height"].replace("px", "");
            var fontSize = +data.text.css["font-size"].replace("px", "");
            return "".concat(((lineHeight / fontSize) * 100).toFixed(0), "%");
        }
        else {
            return "120%";
        }
    }), selectLineHeight = _l[0], setSelectLineHeight = _l[1];
    var _m = (0, react_1.useState)(function () { return (data ? data.text.css["font-weight"] : "400"); }), fontWeight = _m[0], setFontWeight = _m[1];
    var _o = (0, react_1.useState)(function () {
        return data ? data.text.css["text-decoration"] : "none";
    }), textDecoration = _o[0], setTextDecoration = _o[1];
    var _p = (0, react_1.useState)(function () { return (data ? data.text.css["font-style"] : "normal"); }), fontStyle = _p[0], setFontStyle = _p[1];
    var _q = (0, react_1.useState)(false), showTextcolor = _q[0], setShowTextcolor = _q[1];
    var _r = (0, react_1.useState)(function () { return (data ? data.text.css["color"] : "#000"); }), textcolor = _r[0], setTextcolor = _r[1];
    var backcolor = (0, react_1.useMemo)(function () { return "#fff"; }, []);
    var _s = (0, react_1.useState)(function () { return (data ? data.text.lineCount : 0); }), lineCount = _s[0], setLineCount = _s[1];
    var _t = (0, react_1.useState)(function () { return (data ? data.text.sentenceCount : 0); }), sentenceCount = _t[0], setSentenceCount = _t[1];
    var _u = (0, react_1.useState)(function () { return (data ? data.text.wordCount : 0); }), wordCount = _u[0], setWordCount = _u[1];
    var _v = (0, react_1.useState)(function () { return (data ? data.text.charCount : 0); }), charCount = _v[0], setCharCount = _v[1];
    var _w = (0, react_1.useState)(function () {
        // `&nbsp;야생 사과는 키르기스스탄과 중국 서부에 위치한 톈산 산맥과 타림 분지가 원산지로, 이후 전 세계에 퍼지게 되었다. 참고로 다른 과일인 배와 복숭아도 같은 지역이 원산지이다. <br/>&nbsp;사람들은 적어도 기원전 6500년경부터 야생 사과를 채집하기 시작했고, 이후 재배를 하면서 교잡과 접붙이기, 가지치기를 통해 크기를 더 키우고 입맛에 맞는 품종으로 개량했다. 그 결과 현대의 사과가 탄생했다. 현대 사과는 유전자 분석 결과, 적어도 4종의 야생 사과가 섞여 있다고 한다. 이렇게 탄생한 사과는 실크로드를 통해 유라시아 전역으로 퍼졌으며, 이 때문에 고대 교역로 곳곳에서 보관된 사과 씨앗과 묘목이 발견된다.`
        return data ? data.text.html : "\uB0B4\uC6A9\uC744 \uC785\uB825\uD574\uC8FC\uC138\uC694.";
    }), contentText = _w[0], setContentText = _w[1];
    var _x = (0, react_1.useState)(-1), showCanvasAOI = _x[0], setShowCanvasAOI = _x[1];
    var _y = (0, react_1.useState)(), aoiMode = _y[0], setAoiMode = _y[1];
    var _z = (0, react_1.useState)(), fixAoi = _z[0], setFixAoi = _z[1];
    var _0 = (0, react_1.useState)(0), currentSelectTasksIndex = _0[0], setCurrentSelectTasksIndex = _0[1];
    var _1 = (0, react_1.useState)(function () {
        if (data) {
            return data.text.tasks;
        }
        else {
            return [
                {
                    //테스크 한개
                    question: "이 글은 읽기 쉬웠나요?",
                    options: ["매우 읽기 쉽다", "읽기 쉬운편이다", "보통이다", "읽기 어려운 편이다", "매우 읽기 어렵다"],
                    showText: false,
                    correctOption: null,
                    AOI: [],
                },
                // {
                //   //테스크 한개
                //   question: "야생사과의 채집 시기는?",
                //   options: ["기원전 6500년", "300년 전"],
                //   showText: true,
                //   correctOption: "기원전 6500년",
                //   AOI: [
                //     {
                //       left: 0.4,
                //       top: 0.2,
                //       width: 0.436,
                //       height: 0.132,
                //       name: "사과 채집시기 위치",
                //     },
                //   ],
                // },
            ];
        }
    }), tasks = _1[0], setTasks = _1[1];
    var textRef = (0, react_1.useRef)(null);
    var canvasRef = (0, react_1.useRef)(null);
    var textcolorRef = (0, react_1.useRef)(null);
    (0, react_1.useEffect)(function () {
        var handleDocumentMouseDown = function (e) {
            if (showTextcolor) {
                if (!textcolorRef.current || !e.target || !textcolorRef.current.contains(e.target)) {
                    setShowTextcolor(false);
                }
            }
        };
        // 색상 선택 시 드래그때문에 mousedown으로 체크해야함
        if (showTextcolor) {
            document.addEventListener("mousedown", handleDocumentMouseDown);
        }
        return function () {
            document.removeEventListener("mousedown", handleDocumentMouseDown);
        };
    });
    (0, react_1.useEffect)(function () {
        if (!tasks) {
            return;
        }
        var canvas = canvasRef.current;
        if (!canvas) {
            return;
        }
        var ctx = canvas.getContext("2d");
        if (!ctx) {
            return;
        }
        var drawrect = function (name, x, y, width, height, color) {
            ctx.beginPath();
            //   console.log(x + '/' + y + '///' + width + '/' + height);
            ctx.strokeStyle = color; //테두리색
            ctx.lineWidth = 2;
            ctx.strokeRect(x, y, width, height);
            ctx.font = "20px Arial";
            ctx.fillStyle = "blue";
            var textbackwidth = ctx.measureText(name).width;
            ctx.fillRect(x, y - 20, textbackwidth + 10, 22);
            ctx.fillStyle = "white";
            ctx.fillText(name, x + 5, y - 1);
            ctx.stroke();
        };
        var undraw = function () {
            ctx.clearRect(0, 0, canvas.width, canvas.height);
            ctx.beginPath();
        };
        undraw();
        var aois = tasks[currentSelectTasksIndex].AOI;
        if (showCanvasAOI !== -1 && aois.length > 0) {
            var aoi = aois[showCanvasAOI];
            drawrect(aoi.name, aoi.left * 740, aoi.top * 740, aoi.width * 740, aoi.height * 740, "#0000FF");
        }
        else {
            undraw();
        }
    }, [showCanvasAOI, tasks, currentSelectTasksIndex]);
    var getCssObj = (0, react_1.useCallback)(function (el) {
        var style = window.getComputedStyle(el);
        return Object.keys(style).reduce(function (acc, k) {
            var name = style[+k];
            var value = style.getPropertyValue(name);
            var newobj = {};
            if (value !== null) {
                newobj[name] = value;
            }
            return __assign(__assign({}, acc), newobj);
        }, {});
    }, []);
    var cloneDiv = (0, react_1.useCallback)(function (html, cssobj) {
        var tempdiv = document.createElement("div");
        tempdiv.id = "templinecountdiv";
        tempdiv.innerHTML = html;
        for (var key in cssobj) {
            if (key !== "height" && key !== "min-height") {
                // @ts-ignore
                tempdiv.style[key] = cssobj[key];
            }
        }
        tempdiv.style.width = "740px";
        tempdiv.style.height = "auto";
        tempdiv.style.zIndex = "2000";
        return tempdiv;
    }, []);
    var onClickAutoOperation = (0, react_1.useCallback)(function () {
        var _a;
        if (!textRef || !textRef.current) {
            return;
        }
        var html = textRef.current.innerHTML;
        html = html.replace(/<\/div><div>/gi, "<br>");
        html = html.replace(/<div>/gi, "");
        html = html.replace(/<\/div>/gi, "");
        textRef.current.innerHTML = html;
        var text = textRef.current.textContent;
        if (!text) {
            return;
        }
        var wordcount1 = text.trim().replace(/ +/g, " ").split(" ").length + html.split("<br>").length - 1;
        // console.log(wordcount1); // 82  = 24 + 22 17 18
        //#@!
        var charcount = text
            .replace(/\s/g, "")
            .replace(/[{}[\]/?.,;:|)*~`!^\-_+<>@#$%&\\=('，。"]/gi, "")
            .replace(/ +/gi, "").length;
        setCharCount(charcount);
        if (textLanguage === "중국어") {
            setWordCount(charcount);
        }
        else {
            setWordCount(wordcount1);
        }
        // var sentencecount = text.match(/[.?!](\s|$)/g) ? text.match(/[.?!](\s|$)/g).length : 0;
        var sentencecount = text.match(/[^.!?]+[.!?"]+[^".!?]|.+$/g)
            ? (_a = text.match(/[^.!?]+[.!?"]+[^".!?]|.+$/g)) === null || _a === void 0 ? void 0 : _a.length
            : 0;
        // console.log('sc', text.match(/[^.!?]+[.!?"]+[^".!?]|.+$/g));
        setSentenceCount(sentencecount || 0);
        var cssobj = getCssObj(textRef.current);
        var $tmpDiv = cloneDiv(html, cssobj);
        document.body.append($tmpDiv);
        var divHeight = $tmpDiv.offsetHeight;
        var lineheight = +$tmpDiv.style.lineHeight.replace("px", "");
        var linecount = +(divHeight / lineheight).toFixed(0);
        setLineCount(linecount);
        document.body.removeChild($tmpDiv);
        setContentText(html);
    }, [textLanguage, getCssObj, cloneDiv]);
    var textStyle = (0, react_1.useMemo)(function () { return ({
        fontSize: selectFontSize,
        lineHeight: selectLineHeight,
        fontFamily: selectFont,
        color: textcolor,
        backgroundColor: backcolor,
        textAlign: selectAlign,
        fontWeight: fontWeight,
        textDecoration: textDecoration,
        fontStyle: fontStyle,
    }); }, [
        selectFontSize,
        selectLineHeight,
        selectFont,
        textcolor,
        backcolor,
        selectAlign,
        fontWeight,
        textDecoration,
        fontStyle,
    ]);
    var _2 = (0, react_1.useState)(false), isOverflow = _2[0], setIsOverflow = _2[1];
    (0, react_1.useEffect)(function () {
        if (!textRef || !textRef.current || !textStyle || !contentText || !alert) {
            return;
        }
        var html = textRef.current.innerHTML;
        var cssobj = __assign(__assign({}, getCssObj(textRef.current)), textStyle);
        var cloneDivEl = cloneDiv(html, cssobj);
        document.body.append(cloneDivEl);
        var divHeight = cloneDivEl.offsetHeight;
        document.body.removeChild(cloneDivEl);
        if (divHeight > 745) {
            alert.error("텍스트가 지정된 영역을 벗어났습니다.");
        }
        setIsOverflow(divHeight > 745);
    }, [getCssObj, cloneDiv, textStyle, contentText, alert]);
    var infoItemCustomSelectDivStyle = (0, react_1.useMemo)(function () { return ({
        display: "flex",
        alignItems: "center",
        justifyContent: "center",
        width: "60%",
        height: "100%",
    }); }, []);
    return ((0, jsx_runtime_1.jsxs)(StyledEditor, { children: [(0, jsx_runtime_1.jsxs)(StyledContent, { children: [(0, jsx_runtime_1.jsxs)(StyledTitle, __assign({ className: "no-drag" }, { children: [(0, jsx_runtime_1.jsx)("span", { children: "\uC81C\uBAA9" }), (0, jsx_runtime_1.jsx)("input", { type: "text", placeholder: "\uC81C\uBAA9\uC744 \uC785\uB825\uD574\uC8FC\uC138\uC694.", value: textTitle, onChange: setTextTitle })] })), (0, jsx_runtime_1.jsxs)(StyledTextWrap, { children: [(0, jsx_runtime_1.jsx)(AOIViewer_1.default, { ref: canvasRef, showCanvasAOI: showCanvasAOI }), (0, jsx_runtime_1.jsx)(ContentText_1.default, { style: __assign(__assign({}, textStyle), { border: isOverflow ? "none" : "1px solid #333" }), ref: textRef, isOverflow: isOverflow, editable: true, contentText: contentText, onUpdateText: function (html) { return setContentText(html); } }), aoiMode === "add" || (aoiMode === "fix" && fixAoi) ? ((0, jsx_runtime_1.jsx)(AOIModal_1.default, { onClose: function () {
                                    setAoiMode(undefined);
                                }, onSaveAoi: function (aoi) {
                                    if (!tasks) {
                                        return;
                                    }
                                    var aois = tasks[currentSelectTasksIndex].AOI;
                                    var findAoi = aois.find(function (a, i) { return a.name === aoi.name && i !== (fixAoi === null || fixAoi === void 0 ? void 0 : fixAoi.index); });
                                    if (findAoi) {
                                        alert.error("이름 중복");
                                        return;
                                    }
                                    if (aoiMode === "add") {
                                        setTasks(function (state) {
                                            return state.map(function (task, idx) {
                                                return idx === currentSelectTasksIndex
                                                    ? __assign(__assign({}, task), { AOI: __spreadArray(__spreadArray([], task.AOI, true), [aoi], false) }) : task;
                                            });
                                        });
                                    }
                                    else if (aoiMode === "fix" && fixAoi) {
                                        setTasks(function (state) {
                                            return state.map(function (task, idx) {
                                                return idx === currentSelectTasksIndex
                                                    ? __assign(__assign({}, task), { AOI: task.AOI.map(function (a, i) { return (i === fixAoi.index ? aoi : a); }) }) : task;
                                            });
                                        });
                                    }
                                    else {
                                        alert.error("저장 실패");
                                        return;
                                    }
                                    setAoiMode(undefined);
                                    setFixAoi(undefined);
                                }, AOIModalType: aoiMode, AOIdata: fixAoi === null || fixAoi === void 0 ? void 0 : fixAoi.aoi })) : ((0, jsx_runtime_1.jsx)(jsx_runtime_1.Fragment, {}))] })] }), (0, jsx_runtime_1.jsxs)(StyledFormat, __assign({ className: "no-drag" }, { children: [(0, jsx_runtime_1.jsx)(StyledFormatRow, { children: (0, jsx_runtime_1.jsx)(components_1.CustomSelect, { divStyle: { fontFamily: selectFont, fontSize: "0.9rem" }, selectItem: selectFont, selectList: fontList, onSelectItem: function (sel) { return setSelectFont(sel); } }) }), (0, jsx_runtime_1.jsx)(StyledFormatRow, { children: (0, jsx_runtime_1.jsx)(StyledToolbarItem, { children: (0, jsx_runtime_1.jsx)(components_1.CustomNumberInput, { value: selectFontSize, unit: "px", min: 24, max: 60, onUpdateValue: function (val) { return setSelectFontSize("".concat(val, "px")); } }) }) }), (0, jsx_runtime_1.jsx)(StyledFormatRow, { children: (0, jsx_runtime_1.jsx)(StyledToolbarItem, { children: (0, jsx_runtime_1.jsx)(components_1.CustomNumberInput, { value: selectLineHeight, unit: "%", min: 100, max: 200, step: 5, onUpdateValue: function (val) { return setSelectLineHeight("".concat((+val / 100).toFixed(2))); } }) }) }), (0, jsx_runtime_1.jsxs)(StyledFormatRow, { children: [(0, jsx_runtime_1.jsx)(StyledToolbarIcon, __assign({ style: { width: "25%" }, className: fontWeight === "700" ? "active" : "", onClick: function () { return setFontWeight(function (state) { return (state === "700" ? "400" : "700"); }); } }, { children: (0, jsx_runtime_1.jsx)(FontSVG_1.default, { type: "bold", currentColor: fontWeight === "700" ? "#7367f0" : undefined }) })), (0, jsx_runtime_1.jsx)(StyledToolbarIcon, __assign({ style: { width: "25%" }, className: textDecoration === "underline" ? "active" : "", onClick: function () { return setTextDecoration(function (state) { return (state === "underline" ? "none" : "underline"); }); } }, { children: (0, jsx_runtime_1.jsx)(FontSVG_1.default, { type: "underline", currentColor: textDecoration === "underline" ? "#7367f0" : undefined }) })), (0, jsx_runtime_1.jsx)(StyledToolbarIcon, __assign({ style: { width: "25%" }, className: fontStyle === "italic" ? "active" : "", onClick: function () { return setFontStyle(function (state) { return (state === "italic" ? "normal" : "italic"); }); } }, { children: (0, jsx_runtime_1.jsx)(FontSVG_1.default, { type: "italic", currentColor: fontStyle === "italic" ? "#7367f0" : undefined }) })), (0, jsx_runtime_1.jsxs)(StyledToolbarIcon, __assign({ style: { width: "25%" }, ref: textcolorRef }, { children: [(0, jsx_runtime_1.jsxs)(StyledTextColor, __assign({ onClick: function () { return setShowTextcolor(function (state) { return !state; }); } }, { children: [(0, jsx_runtime_1.jsx)(FontSVG_1.default, { type: "font" }), (0, jsx_runtime_1.jsx)(StyledColorBox, { style: { background: textcolor } })] })), (0, jsx_runtime_1.jsx)(StyledColorPicker, __assign({ className: showTextcolor ? "open" : "" }, { children: (0, jsx_runtime_1.jsx)(react_color_1.ChromePicker, { disableAlpha: true, color: textcolor, onChange: function (color) { return setTextcolor(color.hex); }, onChangeComplete: function (color) { return setTextcolor(color.hex); } }) }))] }))] }), (0, jsx_runtime_1.jsx)(StyledFormatRow, { children: (0, jsx_runtime_1.jsx)(StyledToolbarIcon, __assign({ style: { width: "100%" }, onClick: function () {
                                var _a;
                                var text = ((_a = textRef.current) === null || _a === void 0 ? void 0 : _a.textContent) || "";
                                setContentText(text);
                            } }, { children: (0, jsx_runtime_1.jsx)(StyledToolbarItem, { children: "\uC2A4\uD0C0\uC77C \uC81C\uAC70" }) })) })] })), (0, jsx_runtime_1.jsx)(StyledQuestionWrap, __assign({ className: "no-drag" }, { children: (0, jsx_runtime_1.jsx)(ContentQuestion_1.default, { alert: alert, taskList: tasks, Swal: Swal, isOverflow: isOverflow, onUpdateTasks: function (t) { return setTasks(t); }, onUpdateCanvasAOIIndex: function (idx) { return setShowCanvasAOI(idx); }, onUpdateSelectQuestionIndex: function (idx) { return setCurrentSelectTasksIndex(idx); }, onUpdateAOIMode: function (mode, target) {
                        if (mode === "add") {
                            setAoiMode("add");
                        }
                        else {
                            if (!target) {
                                return;
                            }
                            setAoiMode("fix");
                            setFixAoi(target);
                        }
                    } }) })), (0, jsx_runtime_1.jsxs)(StyledInformation, __assign({ className: "no-drag" }, { children: [(0, jsx_runtime_1.jsxs)(StyledInfoItem, { children: [(0, jsx_runtime_1.jsx)(StyledInfoLabel, { children: "\uC5B8\uC5B4" }), (0, jsx_runtime_1.jsx)(components_1.CustomSelect, { divStyle: infoItemCustomSelectDivStyle, selectItem: textLanguage, selectList: languageList, onSelectItem: function (sel) { return setTextLanguage(sel); }, textAlign: "center" })] }), (0, jsx_runtime_1.jsxs)(StyledInfoItem, { children: [(0, jsx_runtime_1.jsx)(StyledInfoLabel, { children: "\uBD84\uC57C" }), (0, jsx_runtime_1.jsx)(components_1.CustomSelect, { divStyle: infoItemCustomSelectDivStyle, selectItem: textType, selectList: textTypeList, onSelectItem: function (sel) { return setTextType(sel); }, textAlign: "center" })] }), (0, jsx_runtime_1.jsxs)(StyledInfoItem, { children: [(0, jsx_runtime_1.jsx)(StyledInfoLabel, { children: "\uB808\uBCA8" }), (0, jsx_runtime_1.jsx)(components_1.CustomSelect, { divStyle: infoItemCustomSelectDivStyle, selectItem: textLevel, selectList: textLevelList, onSelectItem: function (sel) { return setTextLevel(sel); }, textAlign: "center" })] }), (0, jsx_runtime_1.jsxs)(StyledInfoItem, { children: [(0, jsx_runtime_1.jsx)(StyledInfoLabel, { children: "\uC904 \uC218" }), (0, jsx_runtime_1.jsx)(StyledInputWrap, { children: (0, jsx_runtime_1.jsx)("input", { className: !lineCount || lineCount === 0 ? "zero" : "", type: "number", min: "0", max: "99", value: lineCount, onChange: function (e) { return setLineCount(+e.target.value); } }) })] }), (0, jsx_runtime_1.jsxs)(StyledInfoItem, { children: [(0, jsx_runtime_1.jsx)(StyledInfoLabel, { children: "\uBB38\uC7A5 \uC218" }), (0, jsx_runtime_1.jsx)(StyledInputWrap, { children: (0, jsx_runtime_1.jsx)("input", { className: !sentenceCount || sentenceCount === 0 ? "zero" : "", type: "number", min: "0", max: "99", value: sentenceCount, onChange: function (e) { return setSentenceCount(+e.target.value); } }) })] }), (0, jsx_runtime_1.jsxs)(StyledInfoItem, { children: [(0, jsx_runtime_1.jsx)(StyledInfoLabel, { children: "\uC5B4\uC808 \uC218" }), (0, jsx_runtime_1.jsx)(StyledInputWrap, { children: (0, jsx_runtime_1.jsx)("input", { className: !wordCount || wordCount === 0 ? "zero" : "", type: "number", min: "0", max: "99", value: wordCount, onChange: function (e) { return setWordCount(+e.target.value); } }) })] }), (0, jsx_runtime_1.jsxs)(StyledInfoItem, { children: [(0, jsx_runtime_1.jsx)(StyledInfoLabel, { children: "\uAE00\uC790 \uC218" }), (0, jsx_runtime_1.jsx)(StyledInputWrap, { children: (0, jsx_runtime_1.jsx)("input", { className: !charCount || charCount === 0 ? "zero" : "", type: "number", min: "0", max: "99", value: charCount, onChange: function (e) { return setCharCount(+e.target.value); } }) })] }), (0, jsx_runtime_1.jsx)(StyledInfoItem, { children: (0, jsx_runtime_1.jsx)(StyledAutoOperatorBtn, __assign({ onClick: function () { return onClickAutoOperation(); } }, { children: "\uAE00\uC790 \uC218 \uC790\uB3D9\uACC4\uC0B0" })) }), (0, jsx_runtime_1.jsxs)(StyledInfoItem, { children: [(0, jsx_runtime_1.jsx)(StyledInfoLabel, { children: "\uC81C\uC791\uC790" }), (0, jsx_runtime_1.jsx)("span", __assign({ style: { width: "65%", textAlign: "center" } }, { children: "jeong" }))] }), (0, jsx_runtime_1.jsxs)(StyledInfoItem, { children: [(0, jsx_runtime_1.jsx)(StyledInfoLabel, { children: "\uD65C\uC131\uD654" }), (0, jsx_runtime_1.jsx)(components_1.CustomSelect, { divStyle: infoItemCustomSelectDivStyle, selectItem: textActive, selectList: textActiveList, onSelectItem: function (sel) { return setTextActive(sel); }, textAlign: "center" })] }), (0, jsx_runtime_1.jsxs)(StyledInfoItem, { children: [(0, jsx_runtime_1.jsx)(StyledInfoLabel, { children: "\uB808\uBCA8 \uBD84\uB958" }), (0, jsx_runtime_1.jsx)(components_1.CustomSelect, { divStyle: infoItemCustomSelectDivStyle, selectItem: textContentLevel, selectList: textContentLevelList, onSelectItem: function (sel) { return setTextContentLevel(sel); }, textAlign: "center" })] }), (0, jsx_runtime_1.jsxs)(StyledResult, __assign({ style: { height: data ? 160 : 110 } }, { children: [(0, jsx_runtime_1.jsx)(Buttons_1.StyledBtn, __assign({ onClick: function () {
                                    try {
                                        if (!textRef.current) {
                                            throw new Error("글 내용을 가져올 수 없습니다.");
                                        }
                                        var html = textRef.current.innerHTML;
                                        var css = getCssObj(textRef.current);
                                        if (textTitle === "") {
                                            throw new Error("글 제목을 입력해주세요.");
                                        }
                                        if (html === "" || html === "\uB0B4\uC6A9\uC744 \uC785\uB825\uD574\uC8FC\uC138\uC694.") {
                                            throw new Error("글 내용을 입력해주세요.");
                                        }
                                        if (isOverflow) {
                                            throw new Error("글 내용이 영역 안으로 들어가게 해주세요.");
                                        }
                                        if (lineCount === 0 || wordCount === 0 || sentenceCount === 0 || charCount === 0) {
                                            throw new Error("줄, 문장, 어절, 글자 수를 입력해주세요.");
                                        }
                                        for (var i = 1; i < tasks.length; i++) {
                                            if (tasks[i].options.length === 0) {
                                                throw new Error("".concat(i + 1, "\uBC88 \uBB38\uC81C \uBCF4\uAE30\uB97C \uCD94\uAC00\uD574\uC8FC\uC138\uC694."));
                                            }
                                            if (!tasks[i].correctOption) {
                                                throw new Error("".concat(i + 1, "\uBC88 \uBB38\uC81C \uC815\uB2F5\uC744 \uC124\uC815\uD574\uC8FC\uC138\uC694."));
                                            }
                                        }
                                        var saveObject = {
                                            text: {
                                                editor_version: "2.0.0",
                                                name: textTitle,
                                                language: textLanguage,
                                                level: textLevel,
                                                level_changed: textLevel,
                                                domain: textType,
                                                wordCount: wordCount,
                                                lineCount: lineCount,
                                                sentenceCount: sentenceCount,
                                                charCount: charCount,
                                                tasks: tasks,
                                                html: html,
                                                css: __assign(__assign({}, css), { border: "none" }),
                                            },
                                            textset: {
                                                textActive: textActive,
                                                textContentLevel: textContentLevel,
                                            },
                                        };
                                        if (!data) {
                                            // add
                                            setLoading(true);
                                            onSave("add", saveObject).then(function (res) {
                                                if (res.valid) {
                                                    alert.success("저장 성공");
                                                    onClose(true);
                                                }
                                                else {
                                                    alert.error("저장 실패");
                                                    console.error(res.msg);
                                                }
                                            });
                                        }
                                        else {
                                            // fix
                                            setLoading(true);
                                            onSave("fix", saveObject).then(function (res) {
                                                if (res.valid) {
                                                    alert.success("수정 성공");
                                                    onClose(true);
                                                }
                                                else {
                                                    alert.error("수정 실패");
                                                    console.error(res.msg);
                                                }
                                            });
                                        }
                                    }
                                    catch (err) {
                                        if (err instanceof Error) {
                                            alert.error(err.message);
                                        }
                                    }
                                } }, { children: "\uC800\uC7A5" })), (0, jsx_runtime_1.jsx)(Buttons_1.StyledBtn, __assign({ onClick: function () { return onClose(); } }, { children: "\uCDE8\uC18C" })), data && ((0, jsx_runtime_1.jsx)(Buttons_1.StyledBtnRed, __assign({ onClick: function () {
                                    Swal.fire({
                                        icon: "warning",
                                        html: (0, jsx_runtime_1.jsx)("p", { children: "\uC815\uB9D0 \uC0AD\uC81C\uD558\uC2DC\uACA0\uC2B5\uB2C8\uAE4C?" }),
                                        showCancelButton: true,
                                        confirmButtonText: "삭제",
                                        cancelButtonText: "취소",
                                    }).then(function (res) {
                                        if (res.isConfirmed) {
                                            setLoading(true);
                                            onDelete()
                                                .then(function (res) {
                                                if (res.valid) {
                                                    alert.success("삭제 성공");
                                                    onClose(true);
                                                }
                                                else {
                                                    alert.error("삭제 실패");
                                                    console.error(res.msg);
                                                }
                                            })
                                                .catch(function (err) {
                                                if (err instanceof Error) {
                                                    alert.error(err.message);
                                                }
                                            })
                                                .finally(function () { return setLoading(false); });
                                        }
                                    });
                                } }, { children: "\uAE00 \uC0AD\uC81C" })))] }))] }))] }));
};
exports.default = ContentEditor;
var StyledEditor = styled_components_1.default.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  width: 100%;\n  max-width: 1565px;\n  height: 802px; // \uC704\uC544\uB798 padding 10\uC529 + \uD0C0\uC774\uD2C0 50 + \uD14D\uC2A4\uD2B8 742\n\n  display: flex;\n\n  margin: 0 auto;\n\n  * {\n    margin: 0;\n    padding: 0;\n    box-sizing: border-box;\n    font-size: 100%;\n    vertical-align: baseline;\n  }\n"], ["\n  width: 100%;\n  max-width: 1565px;\n  height: 802px; // \uC704\uC544\uB798 padding 10\uC529 + \uD0C0\uC774\uD2C0 50 + \uD14D\uC2A4\uD2B8 742\n\n  display: flex;\n\n  margin: 0 auto;\n\n  * {\n    margin: 0;\n    padding: 0;\n    box-sizing: border-box;\n    font-size: 100%;\n    vertical-align: baseline;\n  }\n"])));
var StyledContent = styled_components_1.default.div(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  width: 760px; // \uD14D\uC2A4\uD2B8\uB4E4 740 x 740 + \uC88C\uC6B0 padding\n  min-width: 760px;\n  height: 100%;\n  padding: 10px;\n  display: flex;\n  flex-direction: column;\n"], ["\n  width: 760px; // \uD14D\uC2A4\uD2B8\uB4E4 740 x 740 + \uC88C\uC6B0 padding\n  min-width: 760px;\n  height: 100%;\n  padding: 10px;\n  display: flex;\n  flex-direction: column;\n"])));
var StyledTitle = styled_components_1.default.div(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  height: 50px;\n  display: flex;\n  align-items: center;\n  span {\n    width: 10%;\n    text-align: center;\n  }\n  input {\n    width: 90%;\n    height: 70%;\n    padding: 0 5px;\n    outline: none;\n    font-size: 20px;\n  }\n"], ["\n  height: 50px;\n  display: flex;\n  align-items: center;\n  span {\n    width: 10%;\n    text-align: center;\n  }\n  input {\n    width: 90%;\n    height: 70%;\n    padding: 0 5px;\n    outline: none;\n    font-size: 20px;\n  }\n"])));
var StyledTextWrap = styled_components_1.default.div(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n  position: relative;\n  width: 740px;\n  height: 740px;\n  margin: 0 auto;\n"], ["\n  position: relative;\n  width: 740px;\n  height: 740px;\n  margin: 0 auto;\n"])));
var StyledFormat = styled_components_1.default.div(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n  min-width: 120px;\n  max-width: 120px;\n  padding-top: 50px;\n  padding-right: 10px;\n  border: none;\n  display: flex;\n  align-items: center;\n  flex-direction: column;\n  gap: 10px;\n  position: relative;\n"], ["\n  min-width: 120px;\n  max-width: 120px;\n  padding-top: 50px;\n  padding-right: 10px;\n  border: none;\n  display: flex;\n  align-items: center;\n  flex-direction: column;\n  gap: 10px;\n  position: relative;\n"])));
var StyledFormatRow = styled_components_1.default.div(templateObject_6 || (templateObject_6 = __makeTemplateObject(["\n  width: 100%;\n  height: 35px; // 50 - 15px\n  position: relative;\n  display: flex;\n  justify-content: center;\n  align-items: center;\n  /* gap: 10px; */\n"], ["\n  width: 100%;\n  height: 35px; // 50 - 15px\n  position: relative;\n  display: flex;\n  justify-content: center;\n  align-items: center;\n  /* gap: 10px; */\n"])));
var StyledToolbarItem = styled_components_1.default.div(templateObject_7 || (templateObject_7 = __makeTemplateObject(["\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  border: none;\n  font-size: 16px;\n  width: 100%;\n  height: 100%;\n  cursor: pointer;\n\n  &.active {\n    color: #7367f0;\n  }\n"], ["\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  border: none;\n  font-size: 16px;\n  width: 100%;\n  height: 100%;\n  cursor: pointer;\n\n  &.active {\n    color: #7367f0;\n  }\n"])));
var StyledToolbarIcon = styled_components_1.default.div(templateObject_8 || (templateObject_8 = __makeTemplateObject(["\n  position: relative;\n  display: flex;\n  justify-content: center;\n  align-items: center;\n\n  border: none;\n\n  cursor: pointer;\n  height: 70%;\n\n  &:hover {\n    color: #7367f0;\n  }\n"], ["\n  position: relative;\n  display: flex;\n  justify-content: center;\n  align-items: center;\n\n  border: none;\n\n  cursor: pointer;\n  height: 70%;\n\n  &:hover {\n    color: #7367f0;\n  }\n"])));
var StyledTextColor = (0, styled_components_1.default)(StyledToolbarItem)(templateObject_9 || (templateObject_9 = __makeTemplateObject(["\n  font-family: \"Roboto Slab\", serif;\n  position: relative;\n  height: 100%;\n"], ["\n  font-family: \"Roboto Slab\", serif;\n  position: relative;\n  height: 100%;\n"])));
var StyledColorBox = styled_components_1.default.div(templateObject_10 || (templateObject_10 = __makeTemplateObject(["\n  width: 110%;\n  height: 3px;\n  position: absolute;\n  top: 110%;\n  background-color: black;\n"], ["\n  width: 110%;\n  height: 3px;\n  position: absolute;\n  top: 110%;\n  background-color: black;\n"])));
var StyledColorPicker = styled_components_1.default.div(templateObject_11 || (templateObject_11 = __makeTemplateObject(["\n  opacity: 0;\n  height: 0;\n  top: 0;\n  overflow: hidden;\n  position: absolute;\n  right: 0;\n  transition: 0.5s;\n\n  &.open {\n    height: auto;\n    top: 150%;\n    opacity: 1;\n    border: 1px solid #333;\n    z-index: 5;\n  }\n"], ["\n  opacity: 0;\n  height: 0;\n  top: 0;\n  overflow: hidden;\n  position: absolute;\n  right: 0;\n  transition: 0.5s;\n\n  &.open {\n    height: auto;\n    top: 150%;\n    opacity: 1;\n    border: 1px solid #333;\n    z-index: 5;\n  }\n"])));
var StyledQuestionWrap = styled_components_1.default.div(templateObject_12 || (templateObject_12 = __makeTemplateObject(["\n  width: 460px;\n  min-width: 460px;\n  box-sizing: content-box;\n"], ["\n  width: 460px;\n  min-width: 460px;\n  box-sizing: content-box;\n"])));
var StyledInformation = styled_components_1.default.div(templateObject_13 || (templateObject_13 = __makeTemplateObject(["\n  display: flex;\n  flex-direction: column;\n  width: 100%;\n  padding-top: 50px;\n  position: relative;\n"], ["\n  display: flex;\n  flex-direction: column;\n  width: 100%;\n  padding-top: 50px;\n  position: relative;\n"])));
var StyledInfoItem = styled_components_1.default.div(templateObject_14 || (templateObject_14 = __makeTemplateObject(["\n  display: flex;\n  align-items: center;\n  width: 100%;\n  height: 50px;\n  border: none;\n  position: relative;\n"], ["\n  display: flex;\n  align-items: center;\n  width: 100%;\n  height: 50px;\n  border: none;\n  position: relative;\n"])));
var StyledInfoLabel = styled_components_1.default.span(templateObject_15 || (templateObject_15 = __makeTemplateObject(["\n  width: 40%;\n  height: 100%;\n  display: flex;\n  justify-content: center;\n  align-items: center;\n"], ["\n  width: 40%;\n  height: 100%;\n  display: flex;\n  justify-content: center;\n  align-items: center;\n"])));
var StyledInputWrap = styled_components_1.default.div(templateObject_16 || (templateObject_16 = __makeTemplateObject(["\n  width: 65%;\n  display: flex;\n  justify-content: center;\n  align-items: center;\n\n  input[type=\"number\"] {\n    width: 70%;\n    height: 70%;\n    font-size: 20px;\n    text-align: center;\n    outline: none;\n\n    &::-webkit-outer-spin-button,\n    &::-webkit-inner-spin-button {\n      appearance: none;\n      margin: 0;\n    }\n\n    &.zero {\n      border: 2px solid rgb(255, 60, 60);\n    }\n  }\n"], ["\n  width: 65%;\n  display: flex;\n  justify-content: center;\n  align-items: center;\n\n  input[type=\"number\"] {\n    width: 70%;\n    height: 70%;\n    font-size: 20px;\n    text-align: center;\n    outline: none;\n\n    &::-webkit-outer-spin-button,\n    &::-webkit-inner-spin-button {\n      appearance: none;\n      margin: 0;\n    }\n\n    &.zero {\n      border: 2px solid rgb(255, 60, 60);\n    }\n  }\n"])));
var StyledAutoOperatorBtn = (0, styled_components_1.default)(Buttons_1.StyledBtnOrange)(templateObject_17 || (templateObject_17 = __makeTemplateObject(["\n  margin: 0 auto;\n  width: 70%;\n"], ["\n  margin: 0 auto;\n  width: 70%;\n"])));
var StyledResult = (0, styled_components_1.default)(StyledInfoItem)(templateObject_18 || (templateObject_18 = __makeTemplateObject(["\n  display: flex;\n  align-items: flex-end;\n  flex-direction: column;\n  width: 100%;\n  height: 160px; // 150 * 3 + 10\n  gap: 10px;\n  position: absolute;\n  bottom: 10px;\n  right: 10px;\n"], ["\n  display: flex;\n  align-items: flex-end;\n  flex-direction: column;\n  width: 100%;\n  height: 160px; // 150 * 3 + 10\n  gap: 10px;\n  position: absolute;\n  bottom: 10px;\n  right: 10px;\n"])));
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6, templateObject_7, templateObject_8, templateObject_9, templateObject_10, templateObject_11, templateObject_12, templateObject_13, templateObject_14, templateObject_15, templateObject_16, templateObject_17, templateObject_18;
